diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/functions.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/functions.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/functions.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/functions.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 59,68 ****
  function current_time( $type, $gmt = 0 ) {
  	switch ( $type ) {
  		case 'mysql':
! 			return ( $gmt ) ? gmdate( 'Y-m-d H:i:s' ) : gmdate( 'Y-m-d H:i:s', ( time() + ( get_option( 'gmt_offset' ) * 3600 ) ) );
  			break;
  		case 'timestamp':
! 			return ( $gmt ) ? time() : time() + ( get_option( 'gmt_offset' ) * 3600 );
  			break;
  	}
  }
--- 59,68 ----
  function current_time( $type, $gmt = 0 ) {
  	switch ( $type ) {
  		case 'mysql':
! 			return ( $gmt ) ? gmdate( 'Y-m-d H:i:s' ) : gmdate( 'Y-m-d H:i:s', ( time() + ( get_option( 'gmt_offset' ) * HOUR_IN_SECONDS ) ) );
  			break;
  		case 'timestamp':
! 			return ( $gmt ) ? time() : time() + ( get_option( 'gmt_offset' ) * HOUR_IN_SECONDS );
  			break;
  	}
  }
***************
*** 214,221 ****
  	if ( $weekday < $start_of_week )
  		$weekday += 7;
  
! 	$start = $day - 86400 * ( $weekday - $start_of_week ); // The most recent week start day on or before $day
! 	$end = $start + 604799; // $start + 7 days - 1 second
  	return compact( 'start', 'end' );
  }
  
--- 214,221 ----
  	if ( $weekday < $start_of_week )
  		$weekday += 7;
  
! 	$start = $day - DAY_IN_SECONDS * ( $weekday - $start_of_week ); // The most recent week start day on or before $day
! 	$end = $start + 7 * DAY_IN_SECONDS - 1; // $start + 7 days - 1 second
  	return compact( 'start', 'end' );
  }
  
***************
*** 458,464 ****
  				if ( false !== $url_parts ) {
  					$extension = pathinfo( $url_parts['path'], PATHINFO_EXTENSION );
  					if ( !empty( $extension ) ) {
! 						foreach ( get_allowed_mime_types( ) as $exts => $mime ) {
  							if ( preg_match( '!^(' . $exts . ')$!i', $extension ) ) {
  								$type = $mime;
  								break;
--- 458,464 ----
  				if ( false !== $url_parts ) {
  					$extension = pathinfo( $url_parts['path'], PATHINFO_EXTENSION );
  					if ( !empty( $extension ) ) {
! 						foreach ( wp_get_mime_types() as $exts => $mime ) {
  							if ( preg_match( '!^(' . $exts . ')$!i', $extension ) ) {
  								$type = $mime;
  								break;
***************
*** 637,652 ****
   */
  function add_query_arg() {
  	$ret = '';
! 	if ( is_array( func_get_arg(0) ) ) {
! 		if ( @func_num_args() < 2 || false === @func_get_arg( 1 ) )
  			$uri = $_SERVER['REQUEST_URI'];
  		else
! 			$uri = @func_get_arg( 1 );
  	} else {
! 		if ( @func_num_args() < 3 || false === @func_get_arg( 2 ) )
  			$uri = $_SERVER['REQUEST_URI'];
  		else
! 			$uri = @func_get_arg( 2 );
  	}
  
  	if ( $frag = strstr( $uri, '#' ) )
--- 637,653 ----
   */
  function add_query_arg() {
  	$ret = '';
! 	$args = func_get_args();
! 	if ( is_array( $args[0] ) ) {
! 		if ( count( $args ) < 2 || false === $args[1] )
  			$uri = $_SERVER['REQUEST_URI'];
  		else
! 			$uri = $args[1];
  	} else {
! 		if ( count( $args ) < 3 || false === $args[2] )
  			$uri = $_SERVER['REQUEST_URI'];
  		else
! 			$uri = $args[2];
  	}
  
  	if ( $frag = strstr( $uri, '#' ) )
***************
*** 654,662 ****
  	else
  		$frag = '';
  
! 	if ( preg_match( '|^https?://|i', $uri, $matches ) ) {
! 		$protocol = $matches[0];
! 		$uri = substr( $uri, strlen( $protocol ) );
  	} else {
  		$protocol = '';
  	}
--- 655,666 ----
  	else
  		$frag = '';
  
! 	if ( 0 === stripos( 'http://', $uri ) ) {
! 		$protocol = 'http://';
! 		$uri = substr( $uri, 7 );
! 	} elseif ( 0 === stripos( 'https://', $uri ) ) {
! 		$protocol = 'https://';
! 		$uri = substr( $uri, 8 );
  	} else {
  		$protocol = '';
  	}
***************
*** 670,676 ****
  			$base = $parts[0] . '?';
  			$query = $parts[1];
  		}
! 	} elseif ( !empty( $protocol ) || strpos( $uri, '=' ) === false ) {
  		$base = $uri . '?';
  		$query = '';
  	} else {
--- 674,680 ----
  			$base = $parts[0] . '?';
  			$query = $parts[1];
  		}
! 	} elseif ( $protocol || strpos( $uri, '=' ) === false ) {
  		$base = $uri . '?';
  		$query = '';
  	} else {
***************
*** 680,693 ****
  
  	wp_parse_str( $query, $qs );
  	$qs = urlencode_deep( $qs ); // this re-URL-encodes things that were already in the query string
! 	if ( is_array( func_get_arg( 0 ) ) ) {
! 		$kayvees = func_get_arg( 0 );
  		$qs = array_merge( $qs, $kayvees );
  	} else {
! 		$qs[func_get_arg( 0 )] = func_get_arg( 1 );
  	}
  
! 	foreach ( (array) $qs as $k => $v ) {
  		if ( $v === false )
  			unset( $qs[$k] );
  	}
--- 684,697 ----
  
  	wp_parse_str( $query, $qs );
  	$qs = urlencode_deep( $qs ); // this re-URL-encodes things that were already in the query string
! 	if ( is_array( $args[0] ) ) {
! 		$kayvees = $args[0];
  		$qs = array_merge( $qs, $kayvees );
  	} else {
! 		$qs[ $args[0] ] = $args[1];
  	}
  
! 	foreach ( $qs as $k => $v ) {
  		if ( $v === false )
  			unset( $qs[$k] );
  	}
***************
*** 898,904 ****
  function wp_get_nocache_headers() {
  	$headers = array(
  		'Expires' => 'Wed, 11 Jan 1984 05:00:00 GMT',
! 		'Last-Modified' => gmdate( 'D, d M Y H:i:s' ) . ' GMT',
  		'Cache-Control' => 'no-cache, must-revalidate, max-age=0',
  		'Pragma' => 'no-cache',
  	);
--- 902,908 ----
  function wp_get_nocache_headers() {
  	$headers = array(
  		'Expires' => 'Wed, 11 Jan 1984 05:00:00 GMT',
! 		'Last-Modified' => '',
  		'Cache-Control' => 'no-cache, must-revalidate, max-age=0',
  		'Pragma' => 'no-cache',
  	);
***************
*** 922,927 ****
--- 926,933 ----
  	$headers = wp_get_nocache_headers();
  	foreach( $headers as $name => $field_value )
  		@header("{$name}: {$field_value}");
+ 	if ( empty( $headers['Last-Modified'] ) && function_exists( 'header_remove' ) )
+ 		@header_remove( 'Last-Modified' );
  }
  
  /**
***************
*** 930,936 ****
   * @since 2.1.0
   */
  function cache_javascript_headers() {
! 	$expiresOffset = 864000; // 10 days
  	header( "Content-Type: text/javascript; charset=" . get_bloginfo( 'charset' ) );
  	header( "Vary: Accept-Encoding" ); // Handle proxies
  	header( "Expires: " . gmdate( "D, d M Y H:i:s", time() + $expiresOffset ) . " GMT" );
--- 936,942 ----
   * @since 2.1.0
   */
  function cache_javascript_headers() {
! 	$expiresOffset = 10 * DAY_IN_SECONDS;
  	header( "Content-Type: text/javascript; charset=" . get_bloginfo( 'charset' ) );
  	header( "Vary: Accept-Encoding" ); // Handle proxies
  	header( "Expires: " . gmdate( "D, d M Y H:i:s", time() + $expiresOffset ) . " GMT" );
***************
*** 1291,1299 ****
--- 1297,1317 ----
   * @return bool Whether the path was created. True if path already exists.
   */
  function wp_mkdir_p( $target ) {
+ 	$wrapper = null;
+ 
+ 	// strip the protocol
+ 	if( wp_is_stream( $target ) ) {
+ 		list( $wrapper, $target ) = explode( '://', $target, 2 );
+ 	}
+ 
  	// from php.net/mkdir user contributed notes
  	$target = str_replace( '//', '/', $target );
  
+ 	// put the wrapper back on the target
+ 	if( $wrapper !== null ) {
+ 		$target = $wrapper . '://' . $target;
+ 	}
+ 
  	// safe mode fails with a trailing slash under certain PHP versions.
  	$target = rtrim($target, '/'); // Use rtrim() instead of untrailingslashit to avoid formatting.php dependency.
  	if ( empty($target) )
***************
*** 1363,1371 ****
  
  /**
   * Determines a writable directory for temporary files.
!  * Function's preference is to WP_CONTENT_DIR followed by the return value of <code>sys_get_temp_dir()</code>, before finally defaulting to /tmp/
!  *
!  * In the event that this function does not find a writable location, It may be overridden by the <code>WP_TEMP_DIR</code> constant in your <code>wp-config.php</code> file.
   *
   * @since 2.5.0
   *
--- 1381,1393 ----
  
  /**
   * Determines a writable directory for temporary files.
!  * Function's preference is the return value of <code>sys_get_temp_dir()</code>,
!  * followed by your PHP temporary upload directory, followed by WP_CONTENT_DIR,
!  * before finally defaulting to /tmp/
!  *
!  * In the event that this function does not find a writable location,
!  * It may be overridden by the <code>WP_TEMP_DIR</code> constant in
!  * your <code>wp-config.php</code> file.
   *
   * @since 2.5.0
   *
***************
*** 1377,1403 ****
  		return trailingslashit(WP_TEMP_DIR);
  
  	if ( $temp )
! 		return trailingslashit($temp);
  
! 	$temp = WP_CONTENT_DIR . '/';
! 	if ( is_dir($temp) && @is_writable($temp) )
! 		return $temp;
  
! 	if  ( function_exists('sys_get_temp_dir') ) {
  		$temp = sys_get_temp_dir();
! 		if ( @is_writable($temp) )
! 			return trailingslashit($temp);
  	}
  
  	$temp = ini_get('upload_tmp_dir');
! 	if ( is_dir($temp) && @is_writable($temp) )
! 		return trailingslashit($temp);
  
  	$temp = '/tmp/';
  	return $temp;
  }
  
  /**
   * Get an array containing the current upload directory's path and url.
   *
   * Checks the 'upload_path' option, which should be from the web root folder,
--- 1399,1458 ----
  		return trailingslashit(WP_TEMP_DIR);
  
  	if ( $temp )
! 		return trailingslashit( rtrim( $temp, '\\' ) );
  
! 	$is_win = ( 'WIN' === strtoupper( substr( PHP_OS, 0, 3 ) ) );
  
! 	if ( function_exists('sys_get_temp_dir') ) {
  		$temp = sys_get_temp_dir();
! 		if ( @is_dir( $temp ) && ( $is_win ? win_is_writable( $temp ) : @is_writable( $temp ) ) ) {
! 			return trailingslashit( rtrim( $temp, '\\' ) );
! 		}
  	}
  
  	$temp = ini_get('upload_tmp_dir');
! 	if ( is_dir( $temp ) && ( $is_win ? win_is_writable( $temp ) : @is_writable( $temp ) ) )
! 		return trailingslashit( rtrim( $temp, '\\' ) );
! 
! 	$temp = WP_CONTENT_DIR . '/';
! 	if ( is_dir( $temp ) && ( $is_win ? win_is_writable( $temp ) : @is_writable( $temp ) ) )
! 		return $temp;
  
  	$temp = '/tmp/';
  	return $temp;
  }
  
  /**
+  * Workaround for Windows bug in is_writable() function
+  *
+  * @since 2.8.0
+  *
+  * @param string $path
+  * @return bool
+  */
+ function win_is_writable( $path ) {
+ 	/* will work in despite of Windows ACLs bug
+ 	 * NOTE: use a trailing slash for folders!!!
+ 	 * see http://bugs.php.net/bug.php?id=27609
+ 	 * see http://bugs.php.net/bug.php?id=30931
+ 	 */
+ 
+ 	if ( $path[strlen( $path ) - 1] == '/' ) // recursively return a temporary file path
+ 		return win_is_writable( $path . uniqid( mt_rand() ) . '.tmp');
+ 	else if ( is_dir( $path ) )
+ 		return win_is_writable( $path . '/' . uniqid( mt_rand() ) . '.tmp' );
+ 	// check tmp file for read/write capabilities
+ 	$should_delete_tmp_file = !file_exists( $path );
+ 	$f = @fopen( $path, 'a' );
+ 	if ( $f === false )
+ 		return false;
+ 	fclose( $f );
+ 	if ( $should_delete_tmp_file )
+ 		unlink( $path );
+ 	return true;
+ }
+ 
+ /**
   * Get an array containing the current upload directory's path and url.
   *
   * Checks the 'upload_path' option, which should be from the web root folder,
***************
*** 1431,1451 ****
   * @return array See above for description.
   */
  function wp_upload_dir( $time = null ) {
- 	global $switched;
  	$siteurl = get_option( 'siteurl' );
! 	$upload_path = get_option( 'upload_path' );
! 	$upload_path = trim($upload_path);
! 	$main_override = is_multisite() && defined( 'MULTISITE' ) && is_main_site();
! 	if ( empty($upload_path) ) {
  		$dir = WP_CONTENT_DIR . '/uploads';
  	} else {
  		$dir = $upload_path;
- 		if ( 'wp-content/uploads' == $upload_path ) {
- 			$dir = WP_CONTENT_DIR . '/uploads';
- 		} elseif ( 0 !== strpos($dir, ABSPATH) ) {
- 			// $dir is absolute, $upload_path is (maybe) relative to ABSPATH
- 			$dir = path_join( ABSPATH, $dir );
- 		}
  	}
  
  	if ( !$url = get_option( 'upload_url_path' ) ) {
--- 1486,1501 ----
   * @return array See above for description.
   */
  function wp_upload_dir( $time = null ) {
  	$siteurl = get_option( 'siteurl' );
! 	$upload_path = trim( get_option( 'upload_path' ) );
! 
! 	if ( empty( $upload_path ) || 'wp-content/uploads' == $upload_path ) {
  		$dir = WP_CONTENT_DIR . '/uploads';
+ 	} elseif ( 0 !== strpos( $upload_path, ABSPATH ) ) {
+ 		// $dir is absolute, $upload_path is (maybe) relative to ABSPATH
+ 		$dir = path_join( ABSPATH, $upload_path );
  	} else {
  		$dir = $upload_path;
  	}
  
  	if ( !$url = get_option( 'upload_url_path' ) ) {
***************
*** 1455,1473 ****
  			$url = trailingslashit( $siteurl ) . $upload_path;
  	}
  
! 	if ( defined('UPLOADS') && !$main_override && ( !isset( $switched ) || $switched === false ) ) {
  		$dir = ABSPATH . UPLOADS;
  		$url = trailingslashit( $siteurl ) . UPLOADS;
  	}
  
! 	if ( is_multisite() && !$main_override && ( !isset( $switched ) || $switched === false ) ) {
! 		if ( defined( 'BLOGUPLOADDIR' ) )
! 			$dir = untrailingslashit(BLOGUPLOADDIR);
! 		$url = str_replace( UPLOADS, 'files', $url );
  	}
  
! 	$bdir = $dir;
! 	$burl = $url;
  
  	$subdir = '';
  	if ( get_option( 'uploads_use_yearmonth_folders' ) ) {
--- 1505,1558 ----
  			$url = trailingslashit( $siteurl ) . $upload_path;
  	}
  
! 	// Obey the value of UPLOADS. This happens as long as ms-files rewriting is disabled.
! 	// We also sometimes obey UPLOADS when rewriting is enabled -- see the next block.
! 	if ( defined( 'UPLOADS' ) && ! ( is_multisite() && get_site_option( 'ms_files_rewriting' ) ) ) {
  		$dir = ABSPATH . UPLOADS;
  		$url = trailingslashit( $siteurl ) . UPLOADS;
  	}
  
! 	// If multisite (and if not the main site in a post-MU network)
! 	if ( is_multisite() && ! ( is_main_site() && defined( 'MULTISITE' ) ) ) {
! 
! 		if ( ! get_site_option( 'ms_files_rewriting' ) ) {
! 			// If ms-files rewriting is disabled (networks created post-3.5), it is fairly straightforward:
! 			// Append sites/%d if we're not on the main site (for post-MU networks). (The extra directory
! 			// prevents a four-digit ID from conflicting with a year-based directory for the main site.
! 			// But if a MU-era network has disabled ms-files rewriting manually, they don't need the extra
! 			// directory, as they never had wp-content/uploads for the main site.)
! 
! 			if ( defined( 'MULTISITE' ) )
! 				$ms_dir = '/sites/' . get_current_blog_id();
! 			else
! 				$ms_dir = '/' . get_current_blog_id();
! 
! 			$dir .= $ms_dir;
! 			$url .= $ms_dir;
! 
! 		} elseif ( defined( 'UPLOADS' ) && ! ms_is_switched() ) {
! 			// Handle the old-form ms-files.php rewriting if the network still has that enabled.
! 			// When ms-files rewriting is enabled, then we only listen to UPLOADS when:
! 			//   1) we are not on the main site in a post-MU network,
! 			//      as wp-content/uploads is used there, and
! 			//   2) we are not switched, as ms_upload_constants() hardcodes
! 			//      these constants to reflect the original blog ID.
! 			//
! 			// Rather than UPLOADS, we actually use BLOGUPLOADDIR if it is set, as it is absolute.
! 			// (And it will be set, see ms_upload_constants().) Otherwise, UPLOADS can be used, as
! 			// as it is relative to ABSPATH. For the final piece: when UPLOADS is used with ms-files
! 			// rewriting in multisite, the resulting URL is /files. (#WP22702 for background.)
! 
! 			if ( defined( 'BLOGUPLOADDIR' ) )
! 				$dir = untrailingslashit( BLOGUPLOADDIR );
! 			else
! 				$dir = ABSPATH . UPLOADS;
! 			$url = trailingslashit( $siteurl ) . 'files';
! 		}
  	}
  
! 	$basedir = $dir;
! 	$baseurl = $url;
  
  	$subdir = '';
  	if ( get_option( 'uploads_use_yearmonth_folders' ) ) {
***************
*** 1482,1488 ****
  	$dir .= $subdir;
  	$url .= $subdir;
  
! 	$uploads = apply_filters( 'upload_dir', array( 'path' => $dir, 'url' => $url, 'subdir' => $subdir, 'basedir' => $bdir, 'baseurl' => $burl, 'error' => false ) );
  
  	// Make sure we have an uploads dir
  	if ( ! wp_mkdir_p( $uploads['path'] ) ) {
--- 1567,1581 ----
  	$dir .= $subdir;
  	$url .= $subdir;
  
! 	$uploads = apply_filters( 'upload_dir',
! 		array(
! 			'path'    => $dir,
! 			'url'     => $url,
! 			'subdir'  => $subdir,
! 			'basedir' => $basedir,
! 			'baseurl' => $baseurl,
! 			'error'   => false,
! 		) );
  
  	// Make sure we have an uploads dir
  	if ( ! wp_mkdir_p( $uploads['path'] ) ) {
***************
*** 1492,1498 ****
  			$error_path = basename( $uploads['basedir'] ) . $uploads['subdir'];
  
  		$message = sprintf( __( 'Unable to create directory %s. Is its parent directory writable by the server?' ), $error_path );
! 		return array( 'error' => $message );
  	}
  
  	return $uploads;
--- 1585,1591 ----
  			$error_path = basename( $uploads['basedir'] ) . $uploads['subdir'];
  
  		$message = sprintf( __( 'Unable to create directory %s. Is its parent directory writable by the server?' ), $error_path );
! 		$uploads['error'] = $message;
  	}
  
  	return $uploads;
***************
*** 1591,1597 ****
  		return array( 'error' => __( 'Empty filename' ) );
  
  	$wp_filetype = wp_check_filetype( $name );
! 	if ( !$wp_filetype['ext'] )
  		return array( 'error' => __( 'Invalid file type' ) );
  
  	$upload = wp_upload_dir( $time );
--- 1684,1690 ----
  		return array( 'error' => __( 'Empty filename' ) );
  
  	$wp_filetype = wp_check_filetype( $name );
! 	if ( ! $wp_filetype['ext'] && ! current_user_can( 'unfiltered_upload' ) )
  		return array( 'error' => __( 'Invalid file type' ) );
  
  	$upload = wp_upload_dir( $time );
***************
*** 1651,1663 ****
   */
  function wp_ext2type( $ext ) {
  	$ext2type = apply_filters( 'ext2type', array(
! 		'audio'       => array( 'aac', 'ac3',  'aif',  'aiff', 'm3a',  'm4a',   'm4b', 'mka', 'mp1', 'mp2',  'mp3', 'ogg', 'oga', 'ram', 'wav', 'wma' ),
! 		'video'       => array( 'asf', 'avi',  'divx', 'dv',   'flv',  'm4v',   'mkv', 'mov', 'mp4', 'mpeg', 'mpg', 'mpv', 'ogm', 'ogv', 'qt',  'rm', 'vob', 'wmv' ),
! 		'document'    => array( 'doc', 'docx', 'docm', 'dotm', 'odt',  'pages', 'pdf', 'rtf', 'wp',  'wpd' ),
! 		'spreadsheet' => array( 'numbers',     'ods',  'xls',  'xlsx', 'xlsb',  'xlsm' ),
! 		'interactive' => array( 'key', 'ppt',  'pptx', 'pptm', 'odp',  'swf' ),
  		'text'        => array( 'asc', 'csv',  'tsv',  'txt' ),
! 		'archive'     => array( 'bz2', 'cab',  'dmg',  'gz',   'rar',  'sea',   'sit', 'sqx', 'tar', 'tgz',  'zip', '7z' ),
  		'code'        => array( 'css', 'htm',  'html', 'php',  'js' ),
  	));
  	foreach ( $ext2type as $type => $exts )
--- 1744,1756 ----
   */
  function wp_ext2type( $ext ) {
  	$ext2type = apply_filters( 'ext2type', array(
! 		'audio'       => array( 'aac', 'ac3',  'aif',  'aiff', 'm3a',  'm4a',   'm4b',  'mka',  'mp1',  'mp2',  'mp3', 'ogg', 'oga', 'ram', 'wav', 'wma' ),
! 		'video'       => array( 'asf', 'avi',  'divx', 'dv',   'flv',  'm4v',   'mkv',  'mov',  'mp4',  'mpeg', 'mpg', 'mpv', 'ogm', 'ogv', 'qt',  'rm', 'vob', 'wmv' ),
! 		'document'    => array( 'doc', 'docx', 'docm', 'dotm', 'odt',  'pages', 'pdf',  'rtf',  'wp',   'wpd' ),
! 		'spreadsheet' => array( 'numbers',     'ods',  'xls',  'xlsx', 'xlsm',  'xlsb' ),
! 		'interactive' => array( 'swf', 'key',  'ppt',  'pptx', 'pptm', 'pps',   'ppsx', 'ppsm', 'sldx', 'sldm', 'odp' ),
  		'text'        => array( 'asc', 'csv',  'tsv',  'txt' ),
! 		'archive'     => array( 'bz2', 'cab',  'dmg',  'gz',   'rar',  'sea',   'sit',  'sqx',  'tar',  'tgz',  'zip', '7z' ),
  		'code'        => array( 'css', 'htm',  'html', 'php',  'js' ),
  	));
  	foreach ( $ext2type as $type => $exts )
***************
*** 1763,1863 ****
  }
  
  /**
!  * Retrieve list of allowed mime types and file extensions.
   *
!  * @since 2.8.6
   *
   * @return array Array of mime types keyed by the file extension regex corresponding to those types.
   */
! function get_allowed_mime_types() {
! 	static $mimes = false;
! 
! 	if ( !$mimes ) {
! 		// Accepted MIME types are set here as PCRE unless provided.
! 		$mimes = apply_filters( 'upload_mimes', array(
! 		'jpg|jpeg|jpe' => 'image/jpeg',
! 		'gif' => 'image/gif',
! 		'png' => 'image/png',
! 		'bmp' => 'image/bmp',
! 		'tif|tiff' => 'image/tiff',
! 		'ico' => 'image/x-icon',
! 		'asf|asx|wax|wmv|wmx' => 'video/asf',
! 		'avi' => 'video/avi',
! 		'divx' => 'video/divx',
! 		'flv' => 'video/x-flv',
! 		'mov|qt' => 'video/quicktime',
! 		'mpeg|mpg|mpe' => 'video/mpeg',
! 		'txt|asc|c|cc|h' => 'text/plain',
! 		'csv' => 'text/csv',
! 		'tsv' => 'text/tab-separated-values',
! 		'ics' => 'text/calendar',
! 		'rtx' => 'text/richtext',
! 		'css' => 'text/css',
! 		'htm|html' => 'text/html',
! 		'mp3|m4a|m4b' => 'audio/mpeg',
! 		'mp4|m4v' => 'video/mp4',
! 		'ra|ram' => 'audio/x-realaudio',
! 		'wav' => 'audio/wav',
! 		'ogg|oga' => 'audio/ogg',
! 		'ogv' => 'video/ogg',
! 		'mid|midi' => 'audio/midi',
! 		'wma' => 'audio/wma',
! 		'mka' => 'audio/x-matroska',
! 		'mkv' => 'video/x-matroska',
! 		'rtf' => 'application/rtf',
! 		'js' => 'application/javascript',
! 		'pdf' => 'application/pdf',
! 		'doc|docx' => 'application/msword',
! 		'pot|pps|ppt|pptx|ppam|pptm|sldm|ppsm|potm' => 'application/vnd.ms-powerpoint',
! 		'wri' => 'application/vnd.ms-write',
! 		'xla|xls|xlsx|xlt|xlw|xlam|xlsb|xlsm|xltm' => 'application/vnd.ms-excel',
! 		'mdb' => 'application/vnd.ms-access',
! 		'mpp' => 'application/vnd.ms-project',
! 		'docm|dotm' => 'application/vnd.ms-word',
! 		'pptx|sldx|ppsx|potx' => 'application/vnd.openxmlformats-officedocument.presentationml',
! 		'xlsx|xltx' => 'application/vnd.openxmlformats-officedocument.spreadsheetml',
! 		'docx|dotx' => 'application/vnd.openxmlformats-officedocument.wordprocessingml',
! 		'onetoc|onetoc2|onetmp|onepkg' => 'application/onenote',
! 		'swf' => 'application/x-shockwave-flash',
! 		'class' => 'application/java',
! 		'tar' => 'application/x-tar',
! 		'zip' => 'application/zip',
! 		'gz|gzip' => 'application/x-gzip',
! 		'rar' => 'application/rar',
! 		'7z' => 'application/x-7z-compressed',
! 		'exe' => 'application/x-msdownload',
! 		// openoffice formats
! 		'odt' => 'application/vnd.oasis.opendocument.text',
! 		'odp' => 'application/vnd.oasis.opendocument.presentation',
! 		'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
! 		'odg' => 'application/vnd.oasis.opendocument.graphics',
! 		'odc' => 'application/vnd.oasis.opendocument.chart',
! 		'odb' => 'application/vnd.oasis.opendocument.database',
! 		'odf' => 'application/vnd.oasis.opendocument.formula',
! 		// wordperfect formats
! 		'wp|wpd' => 'application/wordperfect',
! 		) );
! 	}
! 
! 	return $mimes;
  }
- 
  /**
!  * Retrieve nonce action "Are you sure" message.
   *
!  * Deprecated in 3.4.1 and 3.5.0. Backported to 3.3.3.
   *
!  * @since 2.0.4
!  * @deprecated 3.4.1
!  * @deprecated Use wp_nonce_ays()
!  * @see wp_nonce_ays()
!  *
!  * @param string $action Nonce action.
!  * @return string Are you sure message.
!  */
! function wp_explain_nonce( $action ) {
! 	_deprecated_function( __FUNCTION__, '3.4.1', 'wp_nonce_ays()' );
! 	return __( 'Are you sure you want to do this?' );
  }
  
  /**
--- 1856,1969 ----
  }
  
  /**
!  * Retrieve list of mime types and file extensions.
   *
!  * @since 3.5.0
!  *
!  * @uses apply_filters() Calls 'mime_types' on returned array. This filter should
!  * be used to add types, not remove them. To remove types use the upload_mimes filter.
   *
   * @return array Array of mime types keyed by the file extension regex corresponding to those types.
   */
! function wp_get_mime_types() {
! 	// Accepted MIME types are set here as PCRE unless provided.
! 	return apply_filters( 'mime_types', array(
! 	// Image formats
! 	'jpg|jpeg|jpe' => 'image/jpeg',
! 	'gif' => 'image/gif',
! 	'png' => 'image/png',
! 	'bmp' => 'image/bmp',
! 	'tif|tiff' => 'image/tiff',
! 	'ico' => 'image/x-icon',
! 	// Video formats
! 	'asf|asx|wax|wmv|wmx' => 'video/asf',
! 	'avi' => 'video/avi',
! 	'divx' => 'video/divx',
! 	'flv' => 'video/x-flv',
! 	'mov|qt' => 'video/quicktime',
! 	'mpeg|mpg|mpe' => 'video/mpeg',
! 	'mp4|m4v' => 'video/mp4',
! 	'ogv' => 'video/ogg',
! 	'mkv' => 'video/x-matroska',
! 	// Text formats
! 	'txt|asc|c|cc|h' => 'text/plain',
! 	'csv' => 'text/csv',
! 	'tsv' => 'text/tab-separated-values',
! 	'ics' => 'text/calendar',
! 	'rtx' => 'text/richtext',
! 	'css' => 'text/css',
! 	'htm|html' => 'text/html',
! 	// Audio formats
! 	'mp3|m4a|m4b' => 'audio/mpeg',
! 	'ra|ram' => 'audio/x-realaudio',
! 	'wav' => 'audio/wav',
! 	'ogg|oga' => 'audio/ogg',
! 	'mid|midi' => 'audio/midi',
! 	'wma' => 'audio/wma',
! 	'mka' => 'audio/x-matroska',
! 	// Misc application formats
! 	'rtf' => 'application/rtf',
! 	'js' => 'application/javascript',
! 	'pdf' => 'application/pdf',
! 	'swf' => 'application/x-shockwave-flash',
! 	'class' => 'application/java',
! 	'tar' => 'application/x-tar',
! 	'zip' => 'application/zip',
! 	'gz|gzip' => 'application/x-gzip',
! 	'rar' => 'application/rar',
! 	'7z' => 'application/x-7z-compressed',
! 	'exe' => 'application/x-msdownload',
! 	// MS Office formats
! 	'doc' => 'application/msword',
! 	'pot|pps|ppt' => 'application/vnd.ms-powerpoint',
! 	'wri' => 'application/vnd.ms-write',
! 	'xla|xls|xlt|xlw' => 'application/vnd.ms-excel',
! 	'mdb' => 'application/vnd.ms-access',
! 	'mpp' => 'application/vnd.ms-project',
! 	'docx' => 'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
! 	'docm' => 'application/vnd.ms-word.document.macroEnabled.12',
! 	'dotx' => 'application/vnd.openxmlformats-officedocument.wordprocessingml.template',
! 	'dotm' => 'application/vnd.ms-word.template.macroEnabled.12',
! 	'xlsx' => 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
! 	'xlsm' => 'application/vnd.ms-excel.sheet.macroEnabled.12',
! 	'xlsb' => 'application/vnd.ms-excel.sheet.binary.macroEnabled.12',
! 	'xltx' => 'application/vnd.openxmlformats-officedocument.spreadsheetml.template',
! 	'xltm' => 'application/vnd.ms-excel.template.macroEnabled.12',
! 	'xlam' => 'application/vnd.ms-excel.addin.macroEnabled.12',
! 	'pptx' => 'application/vnd.openxmlformats-officedocument.presentationml.presentation',
! 	'pptm' => 'application/vnd.ms-powerpoint.presentation.macroEnabled.12',
! 	'ppsx' => 'application/vnd.openxmlformats-officedocument.presentationml.slideshow',
! 	'ppsm' => 'application/vnd.ms-powerpoint.slideshow.macroEnabled.12',
! 	'potx' => 'application/vnd.openxmlformats-officedocument.presentationml.template',
! 	'potm' => 'application/vnd.ms-powerpoint.template.macroEnabled.12',
! 	'ppam' => 'application/vnd.ms-powerpoint.addin.macroEnabled.12',
! 	'sldx' => 'application/vnd.openxmlformats-officedocument.presentationml.slide',
! 	'sldm' => 'application/vnd.ms-powerpoint.slide.macroEnabled.12',
! 	'onetoc|onetoc2|onetmp|onepkg' => 'application/onenote',
! 	// OpenOffice formats
! 	'odt' => 'application/vnd.oasis.opendocument.text',
! 	'odp' => 'application/vnd.oasis.opendocument.presentation',
! 	'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
! 	'odg' => 'application/vnd.oasis.opendocument.graphics',
! 	'odc' => 'application/vnd.oasis.opendocument.chart',
! 	'odb' => 'application/vnd.oasis.opendocument.database',
! 	'odf' => 'application/vnd.oasis.opendocument.formula',
! 	// WordPerfect formats
! 	'wp|wpd' => 'application/wordperfect',
! 	) );
  }
  /**
!  * Retrieve list of allowed mime types and file extensions.
   *
!  * @since 2.8.6
   *
!  * @uses apply_filters() Calls 'upload_mimes' on returned array
!  * @uses wp_get_upload_mime_types() to fetch the list of mime types
!  *
!  * @return array Array of mime types keyed by the file extension regex corresponding to those types.
!  */
! function get_allowed_mime_types() {
! 	return apply_filters( 'upload_mimes', wp_get_mime_types() );
  }
  
  /**
***************
*** 1906,1913 ****
  		$function = apply_filters( 'wp_die_ajax_handler', '_ajax_wp_die_handler' );
  	elseif ( defined( 'XMLRPC_REQUEST' ) && XMLRPC_REQUEST )
  		$function = apply_filters( 'wp_die_xmlrpc_handler', '_xmlrpc_wp_die_handler' );
- 	elseif ( defined( 'APP_REQUEST' ) && APP_REQUEST )
- 		$function = apply_filters( 'wp_die_app_handler', '_scalar_wp_die_handler' );
  	else
  		$function = apply_filters( 'wp_die_handler', '_default_wp_die_handler' );
  
--- 2012,2017 ----
